#include <reg167.h>
#include <stdio.h>
#include <intrins.h>

sbit P310 = P3^10;     //port 3 register/bit 10
sbit DP310 = DP3^10;   //DP3-port 3 direction control register

unsigned char idata key, state, input;

/****************************************************/
void f0(void)
{
printf("function f0  ");
}

/****************************************************/
void f1(void)
{
printf("function f1  ");
}
/****************************************************/
void f2(void)
{
printf("function f2  ");
}
/****************************************************/
void f3(void)
{
printf("function f3  ");
}


const (*fpnt[4] [5]) ()=  {                { f0,f1,f0,f1,f0 },
                                           { f1,f0,f1,f0,f0 },
										   { f0,f2,f2,f2,f2 },
										   { f0,f0,f0,f0,f3 }
										   };
										   
unsigned char const nextstate_tab [4] [5]= {
										   { 0,2,2,4,4 },
										   { 1,1,3,3,4 },
										   { 0,0,1,2,3 },
										   { 0,1,2,3,0 }
                                           };		

/****************************************************/


void main(void)
{
//Initialisation
state=0;

// Serial Port

   P310=1;         // set Port 3.10 output latch TxD 
   DP310=1;        // set Port 3.10 direction control TxD out      
   S0TIC=0x80;     // set transmit interrupt flag
   S0BG= 0x33;     // set baudrate 9600 @ 16 MC CPU clock
   S0CON=0x8011;   // set serial mode(1000 0000 0001 0001),
		   // enable rec.,8bit data async,1stop bit


puts("OK\n");

while(1)
{ 

while (!S0RIR);
  key = S0RBUF;
  S0RIR = 0;

  if((key >=0x30) && (key <= 0x39)) input=0;
   else if ((key >= 0x61) && (key <= 0x64)) input=1;
    else if (key == 0x08) input=2;
     else if (key == 0x0D) input=3;

  printf("input = %u\r\n",input);

  (*fpnt[input] [state]) ();
  state = nextstate_tab [input] [state];
  printf("state = %u\r\n\n",state);
  }
}
